<?xml version="1.0"?>
<xsl:stylesheet  version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:math="http://www.w3.org/1998/Math/MathML" >

	<xsl:strip-space elements="*"/>
	<xsl:template match="math:mean">
		<xsl:variable name="array" select="parent::math:apply/*[2]"/>
		<xsl:text>mean(</xsl:text>
		<xsl:value-of select="$array"/>
		<xsl:text>)</xsl:text>
	</xsl:template>
	<xsl:template match="math:int">
		<xsl:variable name="differential" select="translate(../child::math:bvar, ' ','')"/>
		<xsl:variable name="lower-limit" select="translate(../child::math:lowlimit, ' ','')"/>
		<xsl:variable name="upper-limit" select="translate(../child::math:uplimit, ' ','')"/>
                <xsl:choose>
                <!-- Recognizes conext for Sum Rule-->
                <xsl:when test="../child::math:apply/math:plus | ../child::math:apply/math:minus">
                <xsl:call-template name="Sum-Rule">
                    <xsl:with-param name="differential" select="$differential"/>
                    <xsl:with-param name="lower-limit" select="$lower-limit"/>
                    <xsl:with-param name="upper-limit" select="$upper-limit"/>
                </xsl:call-template>
                </xsl:when>
		<!--Example of matching a pattern to replace an integral with the solution(i.e. 1/x from 1.0 to t =&gt; ln(t)-ln(1))
  There are tables of such transforms. Integral and differential; Laplace etc. The only question is effiency and making
   this open source for contributions.-->
		<xsl:when test="../child::math:apply/math:divide/following-sibling::math:cn /following-sibling::math:ci[text()=$differential]">
			<xsl:text>Math.log(</xsl:text>
			<xsl:value-of select="$upper-limit" disable-output-escaping="yes"/>
			<xsl:text>)-Math.log(</xsl:text>
			<xsl:value-of select="$lower-limit" disable-output-escaping="yes"/>
			<xsl:text>);
      </xsl:text>
		</xsl:when>
                </xsl:choose>
	</xsl:template>
        <xsl:template name="Sum-Rule">
		<xsl:param name="differential" select="x"/>
		<xsl:param name="lower-limit" select="0"/>
		<xsl:param name="upper-limit" select="1"/>
                //Sum Rule
                <xsl:for-each select="*">
                //<xsl:value-of select="name()"/>
                </xsl:for-each>
        </xsl:template>
</xsl:stylesheet>
